VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1425
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8310
   LinkTopic       =   "Form1"
   ScaleHeight     =   1425
   ScaleWidth      =   8310
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdUncompress 
      Caption         =   "5"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   12
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4200
      TabIndex        =   5
      Top             =   480
      Width           =   375
   End
   Begin VB.CommandButton cmdCompress 
      Caption         =   "6"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   12
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3360
      TabIndex        =   4
      Top             =   480
      Width           =   375
   End
   Begin VB.TextBox txtCompressed 
      Height          =   285
      Left            =   1320
      TabIndex        =   2
      Top             =   960
      Width           =   5295
   End
   Begin VB.TextBox txtUncompressed 
      Height          =   285
      Left            =   1320
      TabIndex        =   0
      Top             =   120
      Width           =   5295
   End
   Begin VB.Label lblCompressedSize 
      Height          =   255
      Left            =   6720
      TabIndex        =   7
      Top             =   960
      Width           =   1455
   End
   Begin VB.Label lblUncompressedSize 
      Height          =   255
      Left            =   6720
      TabIndex        =   6
      Top             =   120
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Compressed File"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Original File"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Either place the library in the System directory
' or specify the full path to zlib.dll here.
Private Declare Function compress Lib "zlib.dll" (dest As Any, destLen As Any, src As Any, ByVal srcLen As Long) As Long
Private Declare Function uncompress Lib "zlib.dll" (dest As Any, destLen As Any, src As Any, ByVal srcLen As Long) As Long

Private Const Z_OK = 0
Private Const Z_DATA_ERROR = -3
Private Const Z_MEM_ERROR = -4
Private Const Z_BUF_ERROR = -5
Private Sub cmdCompress_Click()
Dim file_name As String
Dim fnum As Integer
Dim uncompressed_size As Long
Dim uncompressed_bytes() As Byte
Dim compressed_size As Long
Dim compressed_bytes() As Byte

    ' **************************************
    ' Load the uncompressed file into a byte array.
    file_name = txtUncompressed.Text
    uncompressed_size = FileLen(file_name)
    ReDim uncompressed_bytes(1 To uncompressed_size)

    fnum = FreeFile
    Open file_name For Binary Access Read As #fnum
    Get #fnum, , uncompressed_bytes()
    Close #fnum
    lblUncompressedSize.Caption = uncompressed_size & " bytes"

    ' **************************************
    ' Compress.

    ' Allocate the smallest allowed compression
    ' buffer (1% larger than the uncompressed data
    ' plus 12 bytes).
    compressed_size = 1.01 * uncompressed_size + 12
    ReDim compressed_bytes(1 To compressed_size)

    ' Compress the bytes.
    Select Case compress( _
            compressed_bytes(1), compressed_size, _
            uncompressed_bytes(1), uncompressed_size)
        Case Z_MEM_ERROR
            MsgBox "Insufficient memory", vbExclamation, _
                "Compression Error"
            Exit Sub
        Case Z_BUF_ERROR
            MsgBox "Buffer too small", vbExclamation, _
                "Compression Error"
            Exit Sub
        ' Else Z_OK.
    End Select

    ' Shrink the compressed buffer to fit.
    ReDim Preserve compressed_bytes(1 To compressed_size)

    ' **************************************
    ' Save the results into the output file.

    ' Remove the existing file.
    On Error Resume Next
    Kill txtCompressed.Text
    On Error GoTo 0

    ' Write the file.
    Open txtCompressed.Text For Binary Access Write As #fnum
    Put #fnum, , compressed_bytes()
    Close #fnum
    lblCompressedSize.Caption = compressed_size & " bytes"

    MsgBox "Done. Compressed " & uncompressed_size & _
        " --> " & compressed_size & " (" & _
        Format$(compressed_size / uncompressed_size * 100, "0.00") & "%)"
    cmdUncompress.Enabled = True
End Sub
Private Sub cmdUncompress_Click()
Dim file_name As String
Dim fnum As Integer
Dim compressed_size As Long
Dim compressed_bytes() As Byte
Dim uncompressed_size As Long
Dim uncompressed_bytes() As Byte

    ' **************************************
    ' Load the file into a byte array.
    file_name = txtCompressed.Text
    compressed_size = FileLen(file_name)
    ReDim compressed_bytes(1 To compressed_size)

    fnum = FreeFile
    Open file_name For Binary Access Read As #fnum
    Get #fnum, , compressed_bytes()
    Close #fnum
    lblCompressedSize.Caption = compressed_size & " bytes"

    ' **************************************
    ' Uncompress.

    ' Allocate room for the uncompressed file.
    ' Note that this routine needs to know
    ' the original file's uncompressed size.
    uncompressed_size = Val(lblUncompressedSize.Caption)
    ReDim uncompressed_bytes(1 To uncompressed_size)

    ' Decompress the bytes.
    Select Case uncompress( _
            uncompressed_bytes(1), uncompressed_size, _
            compressed_bytes(1), compressed_size)
        Case Z_MEM_ERROR
            MsgBox "Insufficient memory", vbExclamation, _
                "Compression Error"
            Exit Sub
        Case Z_BUF_ERROR
            MsgBox "Buffer too small", vbExclamation, _
                "Compression Error"
            Exit Sub
        Case Z_DATA_ERROR
            MsgBox "Input file corrupted", vbExclamation, _
                "Compression Error"
            Exit Sub
        ' Else Z_OK.
    End Select

    ' **************************************
    ' Save the results into the output file.

    ' Remove the existing file.
    file_name = txtUncompressed.Text
    On Error Resume Next
    Kill file_name
    On Error GoTo 0

    ' Write the file.
    Open file_name For Binary Access Write As #fnum
    Put #fnum, , uncompressed_bytes()
    Close #fnum
    lblUncompressedSize.Caption = uncompressed_size & " bytes"

    MsgBox "Done. Uncompressed " & compressed_size & _
        " --> " & uncompressed_size & " (" & _
        Format$(uncompressed_size / compressed_size, "0.00") & "x)"
End Sub

Private Sub Form_Load()
Dim app_path As String

    app_path = App.Path
    If Right$(app_path, 1) <> "\" Then app_path = app_path & "\"

    txtUncompressed.Text = app_path & "test.dat"
    txtCompressed.Text = app_path & "test.zip"
End Sub


